;xxxxxxxxxxxxxxxxxx Blitz Setup xxxxxxxxxxxxxxxxxx

Graphics3D 1024,768,16,2
SetBuffer BackBuffer()

Global player
player = CreatePivot()
PositionEntity player,0,0,0
Global camera
camera = CreateCamera(player)
PositionEntity camera,0,8,0

SeedRnd MilliSecs()

;xxxxxxxxxxxxxxxx Variable Declarations xxxxxxxxxxxx

Global d1$
Global d2$
Global d3$
Global d4$
Global d5$
Global d6$
Global d7$
Global d8$

Global nextscreen$
Global quitflag

Global font01%=HUD_LoadFont("resources\font045_40.png","resources\font045_40.dat",2)

Type mob
	Field spritetex%
	Field sprite%
	Field xpos#
	Field ypos#
	Field zpos#
	Field animframe%
	Field animtimer%
	Field animdir$
	Field animspeed%
	Field sphere%
	Field spheretex%
	Field offsetx#
	Field offsety#
	Field offsetxamount#
	Field offsetyamount#
	Field offsettimer%
	Field offsetspeed%
	Field offsetdir%
End Type

Global HUD_Back%
Global HUD_TI%
Global HUD_SC%

Global HUD_01%
Global playerrune%
Global mobrunes_layer%

Type rune
	Field image%
	Field timer
	Field trailtimer
End Type

Global runetimer1=MilliSecs()

Global trailtimer

Global mouthscore%=0
Global mouthcount%=0

Const runesalpha#=.2

Global runescore%

Global gametimer1

Dim snd(16)
snd(1)=LoadSound("resources\1001.mp3")
snd(2)=LoadSound("resources\1002.mp3")
snd(3)=LoadSound("resources\1003.mp3")
snd(4)=LoadSound("resources\1004.mp3")
snd(5)=LoadSound("resources\1005.mp3")
snd(6)=LoadSound("resources\1006.mp3")
snd(7)=LoadSound("resources\1007.mp3")
snd(8)=LoadSound("resources\1008.mp3")
snd(9)=LoadSound("resources\1009.mp3")
snd(10)=LoadSound("resources\1010.mp3")
snd(11)=LoadSound("resources\1011.mp3")
snd(12)=LoadSound("resources\1012.mp3")
snd(13)=LoadSound("resources\1013.mp3")
snd(14)=LoadSound("resources\1014.mp3")
snd(15)=LoadSound("resources\1015.mp3")

;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

Dim spritetextures%(5)
Dim spheretextures%(5)

spritetextures(0)=LoadAnimTexture("resources\strip005.png",4,128,128,0,16)
spritetextures(1)=LoadAnimTexture("resources\strip007.png",4,128,128,0,16)

spheretextures(0)=LoadTexture("resources\spheretex002.png",4)
spheretextures(1)=LoadTexture("resources\spheretex003.png",4)
spheretextures(2)=LoadTexture("resources\spheretex004.png",4)
spheretextures(3)=LoadTexture("resources\spheretex005.png",4)
spheretextures(4)=LoadTexture("resources\spheretex006.png",4)

;xxxxxxxxxxxxxxxxxxxxxxxx SC Setup xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

Include "sprite candy mg001.bb"

HUD_01%=HUD_Create(camera)

runesfile%=HUD_LoadImageResource("resources\rune300.png",2)
mobrunes_layer%=HUD_CreateLayer(HUD_01,runesfile)
playerrunes_layer%=HUD_CreateLayer(HUD_01,runesfile)
playerrune%=HUD_CreateImage(playerrunes_layer,400,300,128,128)
HUD_SetObjectAlpha(playerrune,runesalpha#)

HUD_AnimateImage(playerrune,0,0,4,2,"NORMAL",0,300)
fxrotate%=HUD_FX_SteadyRotate(playerrune,100)

HUD_Back=HUD_Create(camera)
backroundlayer%=HUD_CreateLayer(HUD_Back)
background%=HUD_CreateShape(backroundlayer,"RECTANGLE",1,0,512,384,1024,768)
HUD_SetObjectColor(background,0,0,0)

;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

nextscreen="Combat_Run"
nextscreen="TI_Run"

Function MainLoop()
End Function


While QuitFlag=False

	Select NextScreen$
	
	
		Case "Combat_Run"
			Combat_Run()
		Case "TI_Run"
			TI_Run()
		Case "SC_Run"
			SC_Run()
		
	End Select

	UpdateScreen()
	
Wend

HUD_RemoveAll True

End


Function Combat_Run()
	
	SetupMain()
	HUD_SetVisibility(HUD_Back,False)

	runescore=0
	gametimer1=MilliSecs()
	turntimer1=MilliSecs()

	Repeat
	
		wkey = KeyDown(17)						
	  	skey = KeyDown(31)
	 	akey = KeyDown(30)
	  	dkey = KeyDown(32)
	  	spacekey=KeyHit(57)
		
		;---------------------------------------------------------------------
		
		spd%=4

		If wkey Then HUD_MoveObject(playerrune,0,-spd)
		If skey Then HUD_MoveObject(playerrune,0,spd)
		If akey Then HUD_MoveObject(playerrune,-spd,0)
		If dkey Then HUD_MoveObject(playerrune,spd,0)
		
		px%=HUD_GetObjectX(playerrune)
		py%=HUD_GetObjectY(playerrune)
	
		If px<10 Then HUD_PositionObject(playerrune,10,py)
		If px>1014 Then HUD_PositionObject(playerrune,1014,py)
		If py<10 Then HUD_PositionObject(playerrune,px,10)
		If py>758 Then HUD_PositionObject(playerrune,px,758)
		
		If spacekey Then FireRune()

		;---------------------------------------------------------------------
	
		
		If KeyHit(1)Then
			quitflag=True
			Return
		End If
				
		
		turntimer2=MilliSecs()
		If (turntimer2-turntimer1)>40 Then
			TurnEntity player, 0,1,0
			turntimer1=MilliSecs()
		End If
		
		
		UpdateMobAnims()
		
		UpdateScreen()

		gametimer2=MilliSecs()
		elapsed=(gametimer2-gametimer1)/1000
		;d2=elapsed
		If elapsed>99 Then 
			;quitflag=True
			HUD_SetVisibility(HUD_Back,True)
			nextscreen="SC_Run"
			Return
		End If
		
		CreateMobRune()
		UpdateMobRunes()
		PlayerRuneTrail()
				
	Forever


End Function


Function DeleteMobs()

	For m.mob=Each mob
		FreeEntity m\sprite
		FreeEntity m\sphere
		Delete m
	Next

End Function


Function SetupMain()

	For loop=1 To 100
		m.mob=New mob
				
		randtex%=Rnd(0,1)
		m\spritetex=spritetextures(randtex)

		m\sprite=CreateSprite()
		m\animframe=0
		m\animtimer=MilliSecs()
		m\animspeed=Rnd(80,150)
		m\animdir="f"
		EntityTexture m\sprite,m\spritetex,m\animframe
		
		sc#=4
		
		ScaleSprite m\sprite,sc,sc
		
		degrees%=Rnd(0,359)
		dist#=Rnd(5,100)
		x=Sin(degrees)*dist
		z=Cos(degrees)*dist

		y=Rnd(4,20)
	
		m\xpos=x
		m\ypos=y
		m\zpos=z
		
		PositionEntity m\sprite,m\xpos,m\ypos,m\zpos
		
		m\sphere=CreateSphere(16)
		EntityAlpha m\sphere,.4
		ScaleEntity m\sphere,4,4,4
		PositionEntity m\sphere,m\xpos,m\ypos-1,m\zpos
		randtex%=Rnd(0,4)
		m\spheretex=spheretextures(randtex)
		EntityTexture m\sphere,m\spheretex
		m\offsetx=0
		m\offsety=0
		m\offsetxamount=.001
		m\offsetyamount=.001
			
		m\offsettimer=MilliSecs()
		;m\offsetspeed=5
		m\offsetspeed=Rnd(4,8)
		m\offsetdir=Rnd(1,4)
		
		boxXscale#=2
		boxYscale#=2
		boxZscale#=2
	
		EntityBox(m\sprite,-boxXscale#,-boxYscale#,-boxZscale#,(boxXscale#*2),(boxYscale#*2),(boxZscale#*2))
		EntityPickMode(m\sprite,3,True)
		
	Next

End Function


Function UpdateMobAnims()

	timenow=MilliSecs()
	
	For m.mob=Each mob
	
		;Sprite anim
		If (timenow-m\animtimer)>m\animspeed Then
			
			If m\animdir="f" Then
				m\animframe=m\animframe+1
			Else
				m\animframe=m\animframe-1
			End If
			
			If m\animframe=15 Then m\animdir="b"
			If m\animframe=0 Then m\animdir="f"

			
			EntityTexture m\sprite,m\spritetex,m\animframe
			
			m\animtimer=MilliSecs()
			
		End If	
		
		
		If (timenow-m\offsettimer)>m\offsetspeed Then
			Select m\offsetdir
				Case 1	;++
					m\offsetx=m\offsetx+m\offsetxamount
					m\offsety=m\offsety+m\offsetyamount
				Case 2	;--
					m\offsetx=m\offsetx-m\offsetxamount
					m\offsety=m\offsety-m\offsetyamount
				Case 3	;+-
					m\offsetx=m\offsetx+m\offsetxamount
					m\offsety=m\offsety-m\offsetyamount
				Case 4	;-+
					m\offsetx=m\offsetx-m\offsetxamount
					m\offsety=m\offsety+m\offsetyamount
			End Select
					
			PositionTexture m\spheretex,m\offsetx,m\offsety
			m\offsettimer=MilliSecs()
		End If
	
	Next

End Function


Function FireRune()

	px%=HUD_GetObjectX(playerrune)
	py%=HUD_GetObjectY(playerrune)
	
	For r.rune=Each rune
		hit=False
		hit=HUD_ObjectHitsObject(playerrune,r\image)
		
		If hit=True Then
			
			randsound%=Rnd(1,15)
			
			PlaySound snd(randsound)
		
			mx%=HUD_GetObjectX(r\image)
			my%=HUD_GetObjectY(r\image)
			
			distance%=HUD_GetDistance(px,py,mx,my)
			
			HUD_RemoveObject(r\image)
			Delete r
			
			hitscore=100-distance
			If hitscore<1 Then hitscore=1
			
			runescore=runescore + hitscore
			
			;check if hit 3d sprite
			picked=CameraPick(camera,px,py)

			For m.mob=Each mob
				If m\sprite=picked Then
					EntityColor m\sprite,255,0,0				
				End If
			Next
		
		End If
	
	Next

End Function


Function CreateMobRune()

	runetimer2=MilliSecs()
	
	If (runetimer2-runetimer1)>1500 Then
	
		r.rune=New rune
		xpos%=Rnd(200,600)
		ypos%=Rnd(200,400)
		r\image=HUD_CreateImage(mobrunes_layer,xpos,ypos,128,128)
		
		HUD_AnimateImage(r\image,0,0,4,2,"NORMAL",0,300)

		
		fx%=HUD_FX_Shake(r\image,200,200,6000)
		
		HUD_SetObjectAlpha(r\image,runesalpha#)
		
		r\timer=MilliSecs()
		r\trailtimer=MilliSecs()
	
		runetimer1=MilliSecs()
		
		fxrotate%=HUD_FX_SteadyRotate(r\image,100)

	End If

End Function


Function PlayerRuneTrail()

	; MOTION TRAIL
	If MilliSecs() - trailtimer > 50 Then
		trailtimer = MilliSecs()
		Temp% = HUD_CreateCopy(playerrune)
		HUD_SetObjectAlpha Temp,runesalpha#
		HUD_FX_AlphaFade   Temp,0,400
		HUD_FX_AutoRemove  Temp,400
	End If

End Function


Function UpdateMobRunes()

	deletetimer=MilliSecs()

	For r.rune=Each rune
	
		; MOTION TRAIL
		If MilliSecs() - r\trailtimer > 50 Then
			r\trailtimer = MilliSecs()
			Temp% = HUD_CreateCopy(r\image)
			HUD_SetObjectAlpha Temp,runesalpha#
			HUD_FX_AlphaFade   Temp,0,400
			HUD_FX_AutoRemove  Temp,400
		End If
	
	
		If (deletetimer-r\timer)>5000 Then
		
			PlayerHP=PlayerHP-100
			
			runescoremax=runescoremax + 100
			
			HUD_RemoveObject(r\image)
			Delete r
		
		End If	
	
	Next

End Function


Function TI_Setup()

	HUD_TI%=HUD_Create(camera)
	
	backroundlayer%=HUD_CreateLayer(HUD_TI)
	background%=HUD_CreateShape(backroundlayer,"RECTANGLE",1,0,512,384,1024,768)
	;HUD_SetObjectColor(background,100,100,100)
	HUD_SetObjectColor(background,0,0,0)

	textlayer01%=HUD_CreateLayer(HUD_TI,font01)

	txtFizzhog%=HUD_CreateText(textlayer01,100,600,"www.fizzhog.com")
	HUD_SetTextFlow(txtFizzhog,"LEFT")

	txtTitle%=HUD_CreateText(textlayer01,100,100,"Michael")
	HUD_SetTextFlow(txtTitle,"LEFT")
	
	txtControls%=HUD_CreateText(textlayer01,100,450,"Controls: WASD and Space")
	HUD_SetTextFlow(txtControls,"LEFT")
	
	txtCredits%=HUD_CreateText(textlayer01,100,200,"a game by fizzhog for Ludum Dare 35")
	HUD_SetTextFlow(txtCredits,"LEFT")

	txtVersion%=HUD_CreateText(textlayer01,100,650,"version 1.00")
	HUD_SetTextFlow(txtVersion,"LEFT")

End Function


Function TI_Run()
	
	;HidePointer
	
	TI_Setup()
	
	go%=False
	
	Repeat
	
		spacekey=KeyHit(57)
		rtnkey=KeyHit(28)
	
		If spacekey Then go=True
		If rtnkey Then go=True
		
		If go=True Then
			TI_Unload()
			nextscreen="Combat_Run"
			Return
		End If
		
		
		If KeyHit(1)Then
			quitflag=True
			Return
		End If
	
		UpdateScreen()
	
	Forever

End Function


Function TI_Unload()

	HUD_Remove(HUD_TI)

End Function


Function SC_Setup()

	HUD_SC%=HUD_Create(camera)
	
	backroundlayer%=HUD_CreateLayer(HUD_SC)
	background%=HUD_CreateShape(backroundlayer,"RECTANGLE",1,0,512,384,1024,768)
	;HUD_SetObjectColor(background,100,100,100)
	HUD_SetObjectColor(background,0,0,0)

	textlayer01%=HUD_CreateLayer(HUD_SC,font01)

	txtTitle%=HUD_CreateText(textlayer01,512,384,runescore)
	HUD_SetTextFlow(txtTitle,"CENTER")

End Function


Function SC_Run()
	
	SC_Setup()
	
	UpdateScreen()
	
	DeleteMobs()
		
	Delay 5000
	
	FlushKeys
	
	go%=False
	
	Repeat
	
		spacekey=KeyHit(57)
		rtnkey=KeyHit(28)
	
		If spacekey Then go=True
		If rtnkey Then go=True
		
		If go=True Then
			SC_Unload()
			nextscreen="TI_Run"
			Return
		End If
		
		
		If KeyHit(1)Then
			quitflag=True
			Return
		End If
	
		UpdateScreen()
	
	Forever

End Function


Function SC_Unload()

	HUD_Remove(HUD_SC)

End Function


Function PrintOnScreen()
	
	Text 0,10,d1
	Text 0,20,d2
	Text 0,30,d3
	Text 0,40,d4
	Text 0,50,d5
	Text 0,60,d6
	Text 0,70,d7
	Text 0,80,d8

End Function


Function UpdateScreen()

	UpdateWorld
	
	HUD_Update
	
	RenderWorld 
	
	PrintOnScreen()
	
	Flip 
	
	Delay 10

End Function





















